function  norm  = Norm_Lp(f,t,lp,err)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
ParametersPhysic;
switch P
     case 0, N_q = 2;
     case 1, N_q = 3;
     case 2, N_q = 4; 
     case 3, N_q = 5; 
     case 4, N_q = 6; 
     case 5, N_q = 7;  
     case 6, N_q = 8; 
     case 7, N_q = 9;     
     otherwise disp('quadrature tall 1-9');
end 

norm=zeros(1,1);
norm_j=0;
f_h=0;
f_sol=zeros(P+1,N);
 for j=1 : 1: N
    norm_j=0;
    for q= 1: 1 :N_q
        f_h=0;
        [w, xp] = quadrature(N_q);
        x = 0.5 * D_x(j) * xp(q) + Centers(j);
        
        for k =1 : 1 : P+1       
            phi_jk= Basis_functions(k,1,j,x);
            if(err == 0) 
                f_h = f_h + f(k,j) * phi_jk;
            end
            if(err == 1)  
                
            switch Model
                case 1, f_sol = Solution_advection(t);
                case 2, [E_sol, B_sol] = Solution_Maxwell(t); 
                        if(n_var ==1) f_sol=E_sol; end 
                        if(n_var ==2) f_sol=B_sol; end 
                case 3, [r_sol, u_sol, E_sol] = Solution_Euler(t); 
                        if(n_var ==1) f_sol=r_sol; end 
                        if(n_var ==2) f_sol=u_sol; end 
                        if(n_var ==3) f_sol=E_sol; end 
                case 4, [r_sol, u_sol,uy_sol,uz_sol, E_sol,By_sol,Bz_sol] = Solution_MHD(t); 
                        if(n_var ==1) f_sol=r_sol; end 
                        if(n_var ==2) f_sol=u_sol; end 
                        if(n_var ==3) f_sol=uy_sol; end 
                        if(n_var ==4) f_sol=uz_sol; end 
                        if(n_var ==5) f_sol=E_sol; end    
                        if(n_var ==6) f_sol=By_sol; end 
                        if(n_var ==7) f_sol=Bz_sol; end 
                case 5, [E_sol, F_sol] = Solution_P1(t); 
                        if(n_var ==1) f_sol=E_sol; end 
                        if(n_var ==2) f_sol=F_sol; end   
                otherwise disp('no exact solution for this model');
            end
                f_h = f_h + (f(k,j)- f_sol(k,j)) * phi_jk;
            end
        end
        if(lp ==0 ) 
        norm_j = norm_j + w(q) * f_h;   
        else   
        f_h = mpower(abs(f_h),lp);
        norm_j = norm_j + w(q) * f_h;
        end
        
    end   
    norm_j = norm_j * 0.5 * D_x(j);
    norm = norm + norm_j;   
 end
if(lp > 0)
norm =mpower(norm,1/lp);
end
end

