function [ r_f,u_f,uy_f,uz_f,E_f,By_f,Bz_f ] = RK_solving_MHD(r,u,uy,uz,E,By,Bz,rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
r_f=zeros(P+1,N);
u_f=zeros(P+1,N);
uy_f=zeros(P+1,N);
uz_f=zeros(P+1,N);
E_f=zeros(P+1,N);
By_f=zeros(P+1,N);
Bz_f=zeros(P+1,N);
RK_total_step=P+1;
switch RK_total_step
    case 1, [r_f,u_f,uy_f,uz_f,E_f,By_f,Bz_f ]=RK_First_Order_MHD(r,u,uy,uz,E,By,Bz,rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim,dt)
    case 2, [r_f,u_f,uy_f,uz_f,E_f,By_f,Bz_f ]=RK_Second_Order_MHD(r,u,uy,uz,E,By,Bz,rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim,dt)
    case 3, [r_f,u_f,uy_f,uz_f,E_f,By_f,Bz_f ]=RK_Third_Order_MHD(r,u,uy,uz,E,By,Bz,rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim,dt)
    otherwise [r_f,u_f,uy_f,uz_f,E_f,By_f,Bz_f ]=RK_Third_Order_MHD(r,u,uy,uz,E,By,Bz,rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim,dt) 
end


end

function [ r_1,u_1,uy_1,uz_1,E_1,By_1,Bz_1  ]=RK_First_Order_MHD(r,u,uy,uz,E,By,Bz,rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;        
r_1=zeros(P+1,N);
u_1=zeros(P+1,N);
uy_1=zeros(P+1,N);
uz_1=zeros(P+1,N);
E_1=zeros(P+1,N);
By_1=zeros(P+1,N);
Bz_1=zeros(P+1,N);

f_r=zeros(P+1,N);
f_ru=zeros(P+1,N);
f_ruy=zeros(P+1,N);
f_ruz=zeros(P+1,N);
f_E=zeros(P+1,N);
f_By=zeros(P+1,N);
f_Bz=zeros(P+1,N);

[rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim]=BC_MHD(r,u,uy,uz,E,By,Bz);
[f_r, f_ru, f_ruy,f_ruz, f_E,f_By,f_Bz]=Solvers_MHD(r,u,uy,uz,E,By,Bz,rLim,uLim,uyLim,uzLim,ELim,ByLim,BzLim);
 
  
r_1=r+dt*f_r;
u_1=r.*u+dt*f_ru;
u_1=u_1./r_1;

uy_1=r.*uy+dt*f_ruy;
uy_1=uy_1./r_1;

uz_1=r.*uz+dt*f_ruz;
uz_1=uz_1./r_1;

E_1=E+dt*f_E;
By_1=By+dt*f_By;
Bz_1=Bz+dt*f_Bz;

end

