function [ u_final ] = RK_solving_advection(u,S_u,uLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
ParametersPhysic;

u_final=zeros(P+1,N);
RK_total_step=P+1;
switch RK_total_step
    case 1, u_final=RK_First_Order_Advection(u,S_u,uLim,dt);
    case 2, u_final=RK_Second_Order_Advection(u,S_u,uLim,dt);
    case 3, u_final=RK_Third_Order_Advection(u,S_u,uLim,dt);   
    otherwise u_final=RK_Third_Order_Advection(u,S_u,uLim,dt);
end


end

function [ u_1 ] = RK_First_Order_Advection(u,S_u,uLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D; 
 ParametersPhysic;
 
u_1=zeros(P+1,N);
flux_u=zeros(P+1,N);

uLim=BC_advection(u);
flux_u=Solvers_advection(u,uLim); 
  
u_1=u+dt*(flux_u+S_u);


end

function [ u_2 ] = RK_Second_Order_Advection(u,S_u,uLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;  
 ParametersPhysic;
 
u_1=zeros(P+1,N);
u_2=zeros(P+1,N);
flux_u=zeros(P+1,N);

uLim=BC_advection(u);
flux_u=Solvers_advection(u,uLim); 
  
u_1=u+dt*(flux_u+S_u);
uLim=BC_advection(u_1);
if(slope == 1) 
    u_1=SlopelimitN(u_1,uLim); 
end

flux_u=Solvers_advection(u_1,uLim); 

u_2=0.5*(u+u_1)+0.5*dt*(flux_u+S_u);
uLim=BC_advection(u_2);
if(slope == 1)   
    u_2=SlopelimitN(u_2,uLim);
end
end

function [ u_3 ] = RK_Third_Order_Advection(u,S_u,uLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
  Globals1D;
  ParametersPhysic;
  
u_1=zeros(P+1,N);
u_2=zeros(P+1,N);
u_3=zeros(P+1,N);
flux_u=zeros(P+1,N);

uLim=BC_advection(u);
flux_u=Solvers_advection(u,uLim); 
  
u_1=u+dt*(flux_u+S_u);

uLim=BC_advection(u_1);
if(slope == 1) 
    u_1=SlopelimitN(u_1,uLim);
end

flux_u=Solvers_advection(u_1,uLim); 

u_2=0.25*(3* u+u_1+dt*(flux_u+S_u));

uLim=BC_advection(u_2);
if(slope == 1) 
    u_2=SloplimitN(u_2,ulim);
end

flux_u=Solvers_advection(u_2,uLim); 

u_3=(1/3)*(u+2*u_2+2*dt*(flux_u+S_u));
uLim=BC_advection(u_3);
if(slope == 1) 
    u_3=SloplimitN(u_3,uLim);
end
end


