function ulimit = SlopeLimitN(u,uLim);

% function ulimit = SlopeLimitN(u);
% Purpose: Apply slopelimiter (Pi^N) to u assuming u an N'th order polynomial            

Globals1D;


uh = invV*u; uh(2:P+1,:)=0; uavg = V*uh; v = uavg(1,:);
uhLim=invV*uLim; uhLim(2:P+1,:)=0; uavgLim = V*uhLim; vLim = uavgLim(1,:);

% Apply slope limiter as needed.
ulimit = u; eps0=1.0e-8;

x=zeros(P+1,N);
for j=1:1:N
    for k=1:1:P+1
            x(k,j)=Degrees_freedom(k,j);
    end
end
% find end values of each element
ue1 = u(1,:); ue2 = u(end,:);

% find cell averages
vk = v; vkm1 = [vLim(1),v(1:N-1)]; vkp1 = [v(2:N),vLim(2)]; 

% Apply reconstruction to find elements in need of limiting
ve1 = vk - minmod([(vk-ue1);vk-vkm1;vkp1-vk]);
ve2 = vk + minmod([(ue2-vk);vk-vkm1;vkp1-vk]);
ids = find(abs(ve1-ue1)>eps0 | abs(ve2-ue2)>eps0);

   
% Check to see if any elements require limiting
if(~isempty(ids))
       
  % create piecewise linear solution for limiting on specified elements
  uhl = invV*u(:,ids); uhl(3:P+1,:)=0; ul = V*uhl;
    
  % apply slope limiter to selected elements
  ulimit(:,ids) = SlopeLimitLin(ul,x(:,ids),vkm1(ids),vk(ids),vkp1(ids));
end
return;
