function [ u_temp ] = Solvers_advection(u,uLim)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
  Globals1D;
ParametersPhysic;
  
 u_temp=zeros(P+1,N);
 uLm=zeros(P+1,1);
 uLp=zeros(P+1,1);
 uRm=zeros(P+1,1);
 uRp=zeros(P+1,1);
 

 
 for j = 1 : 1 : N 
     
    xR=Nodes(j+1);
    xL=Nodes(j);   
      
    uj=u(:,j);
    if( j == 1)
        ujm= uLim(:,1);  
    else    
        ujm=u(:,j-1);
    end     
    if( j == N)
        ujp= uLim(:,2); 
    else    
        ujp=u(:,j+1);
    end 

    if(scheme ==1)
      Fp = flux_upwind(j,1,xR,uj,ujp);
      Fm = flux_upwind(j,-1,xL,ujm,uj);
    end 
    
    if(scheme ==2)
      Fp = flux_centered(j,1,xR,uj,ujp) ;
      Fm = flux_centered(j,-1,xL,ujm,uj);
    end  
  
    u_temp(:,j)= -(InvM(:,:,j)) *( - a * D(:,:,j) * uj + Fp-Fm);
 end
 

end



function F = flux_upwind(j,k,x,uL,uR)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
ParametersPhysic;
K  = eye(P+1);
F = zeros(P+1,1);

if(a > 0)   
for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(k == 1)    
        K(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
     if(k == -1)    
        K(m,l)=Basis_functions(l,1,j-1,x)*Basis_functions(m,1,j,x);
     end
    end
end
   F = a* K * uL;
end

if(a < 0)
for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(k == 1)    
        K(m,l)=Basis_functions(l,1,j+1,x)*Basis_functions(m,1,j,x);
     end
     if(k == -1)    
        K(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
    end
end    
   F = a* K * uR;
  
end
end 

function F = flux_centered(j,i,x,uL,uR)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
ParametersPhysic;

Kp  = eye(P+1);
Km  = eye(P+1);
F = zeros(P+1,1);
for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(i == 1)    
        Kp(m,l)=Basis_functions(l,1,j+1,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
     if(i == -1)    
        Kp(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j-1,x)*Basis_functions(m,1,j,x);
     end
    end
end  

F = a * 0.5 * ( Kp * uR+ Km * uL );

end 

