
%%%%%%%%%%% Definition of the parameters

 Globals1D;
 ParametersPhysic;
 
 %[N,P,test,scheme,Model,nbvar,Tf,LG,LD,CFL,slope] = init_Param(); % initializaion parameter
 L=LD-LG;

 m=Init_physic_parameters();

 [BC, BC_f] = Boundary_condition( ); %type of boundary condition
 
 %%%%%%%%%%%% Mesh
 m=MeshGeneration();

 %%%%%%%%%% local matrices
 r = JacobiGL(0,0,P);
 V  = Vandermonde1D(P, r); invV = inv(V);
 Dr = Dmatrix1D(P, r, V);
 
 M=zeros(P+1,P+1,N);
 D=zeros(P+1,P+1,N);
 InvM=zeros(P+1,P+1,N); 

 for j = 1 : 1 : N
    M(:,:,j)=Matrix_local_integral(1,1,j);
    D(:,:,j)=Matrix_local_integral(2,1,j);
    InvM(:,:,j)=inv(M(:,:,j));
 end    

 %%%%%%%%%%% definition of the unknowns

  switch Model
    case 1, MainAdvection;
    case 2, MainMaxwell;
    case 3, MainEuler;
    case 4, MainMHD; 
    case 5, MainP1;   
    otherwise disp('number of model 1-5');
 end  
       
 
 
 
 
